#include <fstream>
using namespace std;
	
ifstream fin("order.in");
ofstream fout("order.out");
	
int  N;   // nr initial de copii
int  n;   // nr copii ramasi la un moment dat
int lg;   // nr de copii ramasi care trebuie numarati la pasul curent fata de poz 1 

int aib[30003];  // aib[i] = nr de copii ramasi in intervalul asociat lui aib[i] (nr valrilor de 1)
	
void Update(int p, int val)   // adauga sau sterge un copil din aib
{
    for(int i = p; i <= N; i += i & -i) 
		aib[i] += val;
}
		
int Query(int p)  // nr de copii ramasi intre pozitiile 1..n
{	
    int s = 0;
	
    for (int i = p; i >= 1; i -= i & -i) 
		s += aib[i];
	
    return s;
}
	
// returneaza cea mai din stanga pozitie p pt care nr >= lg
int BSearch(int lg) // determina pozitia copilului care trebuie eliminat
{
    int st = 1, dr = N, m = 0, nr = 0, p_min = 0;
	
    while (st <= dr) 
    {
        m = (st + dr) / 2;
        nr = Query(m);     // nr de copii existanti pana la poz m
	
		if (nr >= lg)
		{
			p_min = m;
			dr = m - 1;
		}		
		else
			st = m + 1;
    }
	
    return p_min;
}

// p  1 | 3 | 5 6 | 8 9 10 11 
// lg   2   3     5         8
               
int main() 
{	
    fin >> N;
	
    for (int i = 1; i <= N; i++) 
		Update(i, 1);
	
    n = N, lg = 2;
	
    for (int i = 1; i <= N; i++) 
    {
        int p = BSearch(lg);  // p - poz (nr de ordine) al copilului care trebuie eliminat
        Update(p, -1);        // sterg  
	
        fout << p << ' ';
        n--;    
	
        lg += i;
        if (n) 
			lg = lg % n == 0 ? n : lg % n;
		// daca lungimea depaseste numarul de copii, ajustam lungimea
    }
	
	
    return 0;
}
