#include <fstream>
#include <vector>
#define DIM 31000
using namespace std;

int n;
int A[4 * DIM]; // cate pozitii nearse avem pe interv
int d[DIM];
int ord[DIM];
int x, y, k, sol;

void Build(int,int,int);
void Query(int,int,int);
void Update(int,int,int);

int main()
{
    ifstream fin("schi.in");
    fin >> n;
    for (int i = n; i >= 1; --i)
        fin >> d[i];
    fin.close();

    Build(1, 1, n);
    for (int i = 1; i <= n; ++i)
    {
        sol = 0;
        k = d[i]; // a x-a pozitie nearsa
        Query(1, 1, n);
        Update(1, 1, n);

        ord[sol] = n - i + 1;

    }

    ofstream fout("schi.out");
    for (int i = 1; i <= n; ++i)
        fout << ord[i] << '\n';
    fout.close();

    return 0;
}

void Build(int x, int l, int r)
{
    if (l == r)
    {
        A[x] = 1;
        return;
    }
    
    int m = (l + r) / 2;
    Build(2 * x, l, m);
    Build(2 * x + 1, m + 1, r);
    A[x] = A[2 * x] + A[2 * x + 1];
}

void Query(int x, int l, int r)
{
    if (l == r)
    {
        sol = l;
        return;
    }
    int m = (l + r) / 2;
    if (A[2 * x] >= k)
        Query(2 * x, l, m);
    else
    {
        k -= A[2 * x];
        Query(2 * x + 1, m + 1, r); // caut a (k - A[2 * x]) - a pozitie din intervalul din dreapta
    }
}

void Update(int x, int l, int r)
{
    if (l == r)
    {
        A[x] = 0;
        return;
    }
    int m = (l + r) / 2;
    if (sol <= m) 
		Update(2 * x, l, m);
    else 
		Update(2 * x + 1, m + 1, r);
    A[x] = A[2 * x] + A[2 * x + 1];
}
