#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <deque>

using namespace std;
	
ifstream fin("swap.in");
ofstream fout("swap.out");

const int NMAX = 50005;
int aib[NMAX];
int n;
	
void update(int i, int val) 
{	
    for(; i <= n; i += i & -i)	
        aib[i] += val;
}
	
int query(int i) // suma valorilor de 1 pana la pozitia i
{	
    int sum = 0;	
    for(; i; i -= i & -i)
        sum += aib[i];
    return sum;
}
	
int main() 
{
    string a, b;	
    fin >> a >> b;

    vector<int> fr(30);
	
    for (auto ch : a)	
        fr[ch - 'a']++;
	
    for (auto ch : b)
        fr[ch - 'a']--;
	
    bool havesol = true;
    for (int i = 0; i < 26; ++i)
        if (fr[i] != 0)
            havesol = false;
	
    if (!havesol)
        fout << -1;
    else 
    {
        a = " " + a; // pentru indexare de la 1
        b = " " + b;
        
        vector<deque<int>> pos(30);  // poz[lit] = toate pozitiile pe care se gaseste litera "lit" in sirul a[]
        n = a.size() - 1;
        for (int i = 1; i <= n; ++i)
            pos[a[i] - 'a'].push_back(i);
	
		/* daca a[i] trebuie mutat si anterior au fost mutate k caractere aflate initial pe poz > i,
		 * atunci distanta lui a[i] fata de poz finala ramane constanta: j - 1  (a[i] se deplaseaza cu k poz spre dreapta)
		 * Daca anterior au fost mutate k caractere aflate initial pe poz < i, 
		 * atunci distanta lui a[i] fata de pozitia finala scade cu k: j - 1 - query(i)  (a[i] nu se misca din poz initiala)
		 * 
		 */ 
        int ans = 0;
        for (int i = 1; i <= n; ++i) // iteram in b
        {
			// daca alegem mereu prima aparitie, asiguram nr min de operatii
            int j = pos[b[i] - 'a'].front(); // j - poz urmatoarei aparitii a lui b[i] in a[]
            pos[b[i] - 'a'].pop_front();
            ans += (j - 1 - query(j));  // query(j) - nr de caractere din a[] care sunt mutate deja la inceput, 
            update(j, 1);               // formand un prefix din b[] (lungimea prefixului deja format)
        }
	
        fout << ans;
    }

    return 0;	
}
