#include <cassert>
#include <fstream>
#include <iomanip>
#include <iostream>
using namespace std;

constexpr int N = 1e6 + 1;
ifstream fin("dulciuri.in");
ofstream fout("dulciuri.out");

// |    |    |    |    | ...  |      |
// 0    1    2    3    4     i-1     i
//  a[1] a[2] a[3] a[4]         a[i]

class Aib {
    int aib[N];

   public:
    void Update(int x, int v)
    {
        for (int i = x; i < N; i += i & -i)
			aib[i] += v;
    }

    long long Query(int x) // suma de la poz 1 la x
    {
        long long r = 0;
        for (int i = x; i; i -= i & -i)
			r += aib[i];
        return r;
    }

    long long Query(int st, int dr)
    {
		return Query(dr) - Query(st);
	}

    double Solve(int st, int dr)
    {
        if (st > dr) swap(st, dr);
        if (st == dr)
			return Query(st, st + 1);
        return  Query(st, dr) / double(dr - st);
    }
};

Aib vert, oriz;

int main()
{
    int q, op;
    fin >> q;

    while (q--)
    {
        fin >> op;

        if (op == 1) // indulcire verticala
        {
            int x, v;
            fin >> x >> v;
			x++;     // vezi desenul  (x poate fi 0, dar pozitia in aib[] incepe de la 1)
            vert.Update(x, v);
        }
        else if (op == 2) // indulcire orizontala
        {
            int y, v;
            fin >> y >> v;
            y++;     // vezi desenul (y poate fi 0, dar pozitia in aib[] incepe de la 1)
            oriz.Update(y, v);
        }
        else
        {
            int x1, y1, x2, y2;
            fin >> x1 >> y1 >> x2 >> y2;
            fout << fixed << setprecision(10)
				 << vert.Solve(x1, x2) + oriz.Solve(y1, y2) << '\n';
        }
    }

    return 0;
}
